breed [workers worker]
breed [firms firm]

globals
[wall-open
profit-history 
gdp-red
gdp-blue;
gdp-growth-blue
gdp-growth-red
skew-normal
datamigration
datareturn
realmigration
realreturn
USpriceindex
USpricenow
mexpriceindex
mexpricenow
borderhistory
bordercontrol
datauswage
datamexwage
realuswage
realmexwage
minimum-consumption-red
minimum-consumption-blue
stocksbluedata
realstocks
stockserror
mean-stockserror
flowserror
mean-flowserror]

patches-own
[
residents
county]

firms-own
[employed-workers
counter
people-in-city
wage-here
random-prod]

workers-own
[employed
wealth
relatives
wage-earnings ;employed people receive wage-earnings
network-destination
home-preference 
migrant
return-migrant
beforefirstmig ;indicates whether worker has migrated at least once
moving-probability
return-probability
hometown1 ;x-coordinate of hometown
hometown2 ;y-coordinate of hometown
move-list ;registers whether someone moves in a period
failed-migrant
potential-migrant
neighborlinks
clustering-coefficient
destination-lasttrip
already-counted 
movelist-at-tick48]


undirected-link-breed [informations information ]

links-own
[life

 weight1
 weight2
 weighted-earnings

 ]

to setup
ca
setup-wall
setup-people
setup-firms
setup-links
load-data
;let file1 user-new-file
;if is-string? file1
;[if file-exists? file1
;  [file-delete file1]
; file-open file1
; write-to-file
;]
end

to setup-wall

ask patches with [pxcor = max-pxcor] [set pcolor yellow]
ask patches with [pxcor = min-pxcor] [set pcolor yellow]
ask patches with [pxcor = 0] [set pcolor yellow]
ask n-of (max-pycor * 2 * (1 - bordercontrol)) patches with [pxcor = 0] 
      [set pcolor pink]

end

to setup-people
ask n-of ((number-people * percentage-at-home) / 100) patches with [pxcor > 1 and pxcor < max-pxcor]
    [ sprout-workers 1 [ set color red 
                         set shape "circle"
                         ]
                         
    ]

ask n-of ((number-people * (100 - percentage-at-home)) / 100) patches with [pxcor < (- 1) and pxcor > min-pxcor + 1 ]
    [ sprout-workers 1 [ set color blue 
                         set shape "circle"  
                         
                        ]
     ] 



ask workers [set move-list []
             set beforefirstmig 1
             
             set already-counted 0]
ask workers [set home-preference 4] ; first set it to 4 everywhere, so that the remaining people have home preference 4

ask n-of (number-people *  0.5785) workers [set home-preference 0]
ask n-of (number-people *  0.2996) workers [set home-preference 1]
ask n-of (number-people *  0.0783) workers [set home-preference 2]
ask n-of (number-people *  0.0257) workers [set home-preference 3]




ask workers with [color = red]

     [set relatives workers-on neighbors 
      create-informations-with relatives 
      
      set hometown1 xcor
      set hometown2 ycor]

ask workers with [color = blue]

     [set relatives one-of workers with [color = red ]
      
      set network-destination other workers-on patches in-radius city-size with [pxcor < 0]
      create-information-with relatives 
      create-informations-with network-destination 
      set hometown1 [xcor] of relatives
      set hometown2 [ycor] of relatives
     ]

end

to setup-firms
ask n-of number-firms-blue patches with [pxcor < 0 and pxcor > min-pxcor] [sprout-firms 1  ]
ask firms with [pxcor < 0] [set color green
                            
                            set shape "square"
                            set size 1.5
                            set employed-workers 0
                            set random-prod random-normal 0 0.28 
                            if random-prod < -0.99 [set random-prod -0.99]
                            ]

ask n-of number-firms-red patches with [pxcor > 0 and pxcor < max-pxcor] [sprout-firms 1  ]
ask firms with [pxcor > 0]  [set color yellow
                            
                             set shape "square"
                             set size 1.5
                             set employed-workers 0
                             set random-prod random-normal 0 0.2 
                             if random-prod < -0.99 [set random-prod -0.99]
                             ]
 


end




to setup-links
ask links [set life 1]

end


to load-data



ifelse (file-exists? "skewnormal.txt")
   [
     set skew-normal[]
     file-open "skewnormal.txt"
     while [not file-at-end?]
        [set skew-normal lput file-read skew-normal 
        ]
    file-close
   ]
   [user-message "There is no skewnormal.txt file in current directory!"
   ]





ifelse (file-exists? "migration.txt")
   [
     set datamigration[]
     file-open "migration.txt"
     while [not file-at-end?]
        [set datamigration lput file-read datamigration 
        ]
    file-close
   ]
   [user-message "There is no migration.txt file in current directory!"
   ]

   

ifelse (file-exists? "return.txt")
   [
     set datareturn []
     file-open "return.txt"
     while [not file-at-end?]
        [set datareturn lput file-read datareturn
        ]
    file-close
   ]
   [user-message "There is no return.txt file in current directory!"
   ]

ifelse (file-exists? "mexwage.txt")
   [
     set datamexwage []
     file-open "mexwage.txt"
     while [not file-at-end?]
        [set datamexwage lput file-read datamexwage
        ]
    file-close
   ]
   [user-message "There is no mexwage.txt file in current directory!"
   ]

ifelse (file-exists? "uswage.txt")
   [
     set datauswage []
     file-open "uswage.txt"
     while [not file-at-end?]
        [set datauswage lput file-read datauswage
        ]
    file-close
   ]
   [user-message "There is no uswage.txt file in current directory!"
   ]
   

ifelse (file-exists? "border.txt")
   [
     set borderhistory []
     file-open "border.txt"
     while [not file-at-end?]
        [set borderhistory lput file-read borderhistory
        ]
    file-close
   ]
   [user-message "There is no border.txt file in current directory!"
   ]
   
   
ifelse (file-exists? "USpriceindex.txt")
   [
     set USpriceindex []
     file-open "USpriceindex.txt"
     while [not file-at-end?]
        [set USpriceindex lput file-read USpriceindex
        ]
    file-close
   ]
   [user-message "There is no USpriceindex.txt file in current directory!"
   ]
      
ifelse (file-exists? "mexpriceindex.txt")
   [
     set mexpriceindex []
     file-open "mexpriceindex.txt"
     while [not file-at-end?]
        [set mexpriceindex lput file-read mexpriceindex
        ]
    file-close
   ]
   [user-message "There is no mexpriceindex.txt file in current directory!"
   ]
    
ifelse (file-exists? "stocksblue.txt")
   [
     set stocksbluedata []
     file-open "stocksblue.txt"
     while [not file-at-end?]
        [set stocksbluedata lput file-read stocksbluedata
        ]
    file-close
   ]
   [user-message "There is no stocksblue.txt file in current directory!"
   ]

set stockserror []
set flowserror []
end




to go

reset-values
consume
if ticks > 14 [migrate]
move

stop-at-walls

employ-people

update-wages
if ticks > 14[return]
if ticks > 14 [update-data]

if ticks > 14 [do-plots] 
tick
;if ticks = 48 [ask workers with [color = blue] ;if migrants aren't employed by now: whereever they are is their final destination.
;                  [set destination-lasttrip round xcor * 100 +  round ycor] 
;             ;ask firms with [color = green and any? workers-here] [calculate-population]
;              ask patches with [pxcor < 0 and any? workers-here ][people-here]
;               ask workers [set movelist-at-tick48 length move-list]               
;               set mean-stockserror mean  stockserror
;               set mean-flowserror mean flowserror ]

;if ticks = 17 [;write-to-file
                
;               ]
if ticks = 48 [
              
               stop
               ]
end













to reset-values 
ask workers 
     [if color = blue
                [ create-informations-with other workers-on patches in-radius city-size with [pxcor < 0] [set life 1 ]
                  set network-destination information-neighbors with [pxcor < 0];in each period, workers create new links to others in their city.
                 
                 ]
     ]
ask workers [set moving-probability 0
             set return-probability 0
             if migrant = 2  
                [set migrant 0]
             if migrant = 1 
                   [set migrant 2] 
            if return-migrant = 2  ;same for return-migrants
                [set return-migrant 0]
             if return-migrant = 1 
                   [set return-migrant 2] 
            if failed-migrant = 2
                 [set failed-migrant 0]
            if failed-migrant = 1
                 [set failed-migrant 2]
            if employed = 0 [set wage-earnings 0]
            ;set label length move-list
            set potential-migrant 0
            
            
;            if ticks = 1 or ticks = 32 [let my-neighbor-list [other-end] of my-links ;procedure to calculate clustering coefficient: links that my neighbors have among eachother divided by all links they could possibly have
;            let my-neighbor-set workers with [member? self my-neighbor-list]  ;convert list to agentset
;           
;            ask my-neighbor-set [set neighborlinks count my-links with [other-end = one-of my-neighbor-set]] 
;            
;            ;avoid dividing by 0 when computing clustering-coefficient
;            ifelse count my-links <= 1
;            [set clustering-coefficient 0]
;            [set clustering-coefficient ( 2 * sum [neighborlinks] of my-neighbor-set ) / ( count my-links * (count my-links - 1 ))] 
;            ask my-neighbor-set [set neighborlinks 0]
;            ]

           ]

    


ask links [set life life * (1.02) ;links get 2% older each year 
          
           set weight1 0
           set weight2 0
           set weighted-earnings 0
           ]

ask workers [ifelse any? workers-on neighbors ;except links between close neighbors
                     [let closefriends workers-on neighbors
                       ask my-links with [other-end = one-of closefriends] [set life 1]
                     ]              
                     [
                     ]
            ]     


ifelse ticks > 14 [

set realuswage item (ticks - 15) datauswage
set realmexwage item (ticks - 15) datamexwage
set bordercontrol item (ticks - 15) borderhistory
set USpricenow item (ticks - 15) USpriceindex
set mexpricenow item (ticks - 15) mexpriceindex
set minimum-consumption-red realmexwage * 0.3
set minimum-consumption-blue realuswage * 0.7
]
[set realuswage item 0 datauswage
set realmexwage item 0 datamexwage
set bordercontrol item 0 borderhistory
set USpricenow item 0 USpriceindex
set mexpricenow item 0 mexpriceindex
set minimum-consumption-red realmexwage * 0.3
set minimum-consumption-blue realuswage * 0.7
]



ask firms [ifelse color = green 
               [set wage-here realuswage + random-prod * realuswage
               ]
               [set wage-here realmexwage + random-prod * realmexwage
               ]
          ]



end


to consume 
;workers consume wage-earnings (partly saving possible)  
;what is not consumed is added to wealth    


ask workers [let saving-rate item random 2859 skew-normal 
             set wealth wealth + (saving-rate * wage-earnings)  ;no credit restrictions
             if wage-earnings = 0 ;if people have no wage-earnings they have to use up their wealth
                      [ifelse color = red 
                        [set wealth wealth - minimum-consumption-red]
                        [set wealth wealth - minimum-consumption-blue]
                       ]
             ]
end





to migrate
compute-probability
make-decision


end
;
to compute-probability ; people migrate if their wealth is bigger than the moving costs, if their wage is smaller than the average wage of their information-neigbors 
  ;if they have relatives who migrated (at any point in time) and
;, and if their immediate neighbors in their neighborhood migrated this period.
;their probability decreases if they have failed migrants in their network
  

ask workers with [color = red][if wealth >= moving-costs 
                                     [set moving-probability baseline_migrationprobability
                                     
                                       
                                      if ticks < 19 []
                                      if ticks > 18 [set moving-probability moving-probability + 0.008]
                                      if ticks > 30 [set moving-probability moving-probability - 0.003]
                                      if ticks > 45 [set moving-probability moving-probability - 0.011]   
                                      
                                             
                                              if home-preference = 0 []; parameter homebias = 1 (except for sensitivity analysis)
                                              if home-preference = 1 [set moving-probability moving-probability - parameter-homebias * 0.003]
                                              if home-preference = 2 [set moving-probability moving-probability - parameter-homebias * 0.005]
                                              if home-preference = 3 [set moving-probability moving-probability - parameter-homebias * 0.007]
                                              if home-preference = 4 [set moving-probability moving-probability - parameter-homebias * 0.003]
                                                        
                                     ifelse any? information-neighbors with [color = blue] 
                                             [                                                                                                                                     
                                               let comparative-earnings (sum [wage-earnings] of information-neighbors with [color = blue] ) / count information-neighbors with [color = blue] 
                                                ifelse wage-earnings < comparative-earnings
                                                       [
                                                        ifelse beforefirstmig = 1
                                                                     [set moving-probability moving-probability + 0.0000011 * (comparative-earnings - wage-earnings) * parameter-comparative-earnings ;parameter-comparative-earnings is usually one; can only be altered for sensitivity analysis
                                                                     ]
                                                                     [set moving-probability moving-probability + 0.0000035 * (comparative-earnings - wage-earnings) * parameter-comparative-earnings
                                                                     ]
                                                         
                                                        ask my-links 
                                                            [if [color] of other-end = blue
                                                                      [
                                                                        ask myself [set moving-probability moving-probability + parameter-other-migrants ]
                                                                      ]
                                                            ] 
                                                       
                                                       ]
                                                       [set moving-probability 0
                                                       ]
                                                       
                                             ]
                                             [           
                                             ]
                                      if moving-probability >= 1 [set moving-probability 1] 
                                      ]
                                  ]
end
;
to make-decision
ask workers with [color = red] 
    [if (random-float 1 < moving-probability)
            [set potential-migrant 1
             set wealth wealth - (moving-costs * mexpricenow)
             go-to-border
             ]  
    ]      
              
end
;
to go-to-border
ifelse random-float 1 < bordercontrol
          
                 [set failed-migrant 1
                 ]
                 [set migrant 1
                   set beforefirstmig 0
                   set color blue
                   set employed 0
                 ;now: transform links to relatives into links that can decay
                   set wage-earnings 0
            
                 decide-destination
                 ]

          
end


to decide-destination ; people go either to where they know someone, or to a random patch in the left country.

ifelse any? information-neighbors with [color = blue] 
                     [let informants information-neighbors with [color = blue]    
                      move-to one-of informants with-max [wage-earnings]                   
                      if any? firms-here [set destination-lasttrip round xcor * 100 +  round ycor ]
                     ]
                     [move-to one-of patches with [pxcor < 0]

                     ]
set move-list lput 1 move-list
 
            
end





;
to move
ask workers 
[if color = blue and employed = 0
    [ifelse any? information-neighbors with [employed = 1 and xcor < 0]  ;network helps migrants to find a job
         [move-to one-of information-neighbors with [employed = 1 and xcor < 0] with-max [wage-earnings] 
         set destination-lasttrip round xcor * 100 +  round ycor
         ]
         [
         rt random 40
         lt random 40
         fd 1
         ]
    ]
 if color = red and employed = 0 
   [ifelse any? information-neighbors with [employed = 1 and xcor > 0]
     [move-to one-of information-neighbors with [employed = 1 and xcor > 0] 
      
     ]
     [rt random 40 
       lt random 40
       fd 1
     ]   
   ]
]
end
;
;
;
to stop-at-walls
ask workers [ifelse patch-ahead 1 = nobody
                     [rt 180]

                     [ if pcolor != black 
                                [set heading (- heading)
                                         ifelse patch-ahead 1 = nobody
                                         [rt 180 fd 1
                                         ]
                                         [fd 1
                                         ]
                                ]
                       
                       ifelse patch-ahead 1 = nobody
                       [rt 180 fd 1
                       ] 
                       [if [pcolor] of patch-ahead 1 != black  
                     
                                [set heading (- heading)
                                        ifelse patch-ahead 1 = nobody
                                         [rt 180 fd 1
                                         ]
                                         [fd 1
                                         ]
                                ]                   
                      ]
                     ]  
             ]
  
end
;

to update-firms


end



to employ-people 
ask firms [ifelse color = green
               [ifelse any? workers-here with [employed = 0]
                  [while [any? workers-here with [employed = 0]] 
                     
                    [set employed-workers employed-workers + 1
                      ask one-of workers-here with [employed = 0] 
                      [set employed 1
                       set wage-earnings [wage-here] of myself
                       set destination-lasttrip round xcor * 100 +  round ycor
                       ]
                     
                    ]  
                     
                  ]
                  [                  ]
               ]
               [ifelse any? workers-here with [employed = 0]
                 [
                   while [any? workers-here with [employed = 0]] 
                    
                    [set employed-workers employed-workers + 1 
                      ask one-of workers-here with [employed = 0] 
                      [set employed 1
                       set wage-earnings [wage-here] of myself
                       
                       ]
                     
                    ]
                 ] 
                 [
                 ]

               ]  
          ]
          
          
end
;
to update-wages
ask firms  [if any? workers-here
                [ask workers-here with [employed = 1] [set wage-earnings [wage-here] of myself]]
            ]

end


to return   ;Once they can pay for return: People return for one of several reasons: if their home preference is strong (distribution in population); due to higher purchasing power in home country,i.e., if their
;savings reach a certain precentage of home-country GDP per capita; because their neighbors go home. 
compute-return-probability
return-home

end


to compute-return-probability

ask workers [if color = blue and wealth > return-costs
                  [set return-probability baseline_returnprobability
                                      if ticks < 19 []
                                      if ticks > 18 [set return-probability return-probability + 0.064]
                                      if ticks > 30 [set return-probability return-probability + 0.048]
                                         
                    
                    
                   if any? information-neighbors with [color = red]
                           [ask my-links with [[color] of other-end = red ] [let indicator 1 / life 
                                                         ask myself [set return-probability return-probability + parameter-ties-to-home * indicator]
                                                          ]
                           
                           
                           ]
                  
                  
                 
                  
                 
                  if return-probability > 1 [set return-probability 1]                      
                  ]
             ]


end

to return-home
ask workers with [color = blue] 
    [if (random-float 1 < return-probability)
            [set return-migrant 1
             set wealth wealth - (return-costs * USpricenow) ;pay for return
            set color red
            set employed 0
            set wage-earnings 0
            set xcor hometown1 set ycor hometown2
            create-informations-with workers-on neighbors [set life 1];create new stable links to remaining relatives 
            set move-list lput 1 move-list

            ]
    ]
            
end



to update-data

set realmigration item (ticks - 15)  datamigration 
set realreturn item (ticks - 15 ) datareturn

set realstocks item ( ticks - 15) stocksbluedata 


;if ticks = 16 or ticks = 27 or ticks = 29 or ticks = 47
;[set flowserror lput ((realreturn - ( count workers with [return-migrant = 1] / number-people)) ^ 2 + (realmigration - ( count workers with [migrant = 1] / number-people)) ^ 2) flowserror
;  set stockserror lput (((count workers with [color = blue] / count workers ) - realstocks ) ^ 2) stockserror
;]
end



  
  
  
to do-plots
;;
;;;if ticks > 8
;;;[
set-current-plot "stocks-of-people" ;counts people in both countries
set-current-plot-pen "number-migrants" 
plot count workers with [color = blue] 
set-current-plot-pen "number-home"
plot count workers with [color = red]
set-current-plot-pen "realstocks"
plot realstocks * count workers
;;
;;
;;;set-current-plot "gdp"
;;;set-current-plot-pen "gdp-blue"
;;;plot gdp-blue
;;;set-current-plot-pen "gdp-red"
;;;plot gdp-red
;;
set-current-plot "migrant-flows"
set-current-plot-pen "migrants"
plot count workers with [migrant = 1] / number-people
set-current-plot-pen "data-migrants"
plot realmigration
;;
;;
set-current-plot "return-flows"
set-current-plot-pen "return-migrants"
plot count workers with [return-migrant = 1] / number-people
set-current-plot-pen "data-return-migrants"
plot realreturn
;;
;;
end





;to calculate-population ; firm procedure
;
;let residents workers with [destination-lasttrip = round [pxcor] of one-of patches in-radius city-size * 100 +  round [pycor] of one-of patches in-radius city-size]
;set people-in-city count residents with [already-counted = 0]
;ask residents with [already-counted = 0][set already-counted 1]
;end


;to people-here;patch-procedure
;
;let mayberesidents workers with [destination-lasttrip = round [pxcor] of one-of other patches in-radius city-size * 100 +  round [pycor] of one-of other patches in-radius city-size or 
;                                 destination-lasttrip = round [pxcor] of myself * 100 +  round [pycor] of myself]
;set residents count mayberesidents with [already-counted = 0]
;ask mayberesidents with [already-counted = 0][set already-counted 1]
;
;
;end






;to write-to-file
;foreach sort workers [ask ? [file-print(word "ticks: " ticks "  " self " color: " color " movedhowmanytimes: " length move-list " relatives: " relatives " network: " network-destination )]
;                     ] 
;foreach sort workers [ask ? [file-print(word "ticks: " ticks "  " self " color: " color " movedhowmanytimes: " length move-list )]
 ;                    ]
;;;file-print (word "ticks: " ticks " nevermoved: " count workers with [move-list = []])
;;foreach sort workers [ask ? [if ticks = 1 or ticks = 33 
;;                                 [file-print (word "   ticks:   " ticks  "    :    " "   turtlename:    " self "   :   " "    number_network_neighbors:    " count information-neighbors )
;;                                  ]
;;                            ]
;;                      ] 
;;foreach sort workers [ask ? [if ticks = 33 
;;                                 [file-print (word "   ticks:   " ticks  "    :    " "   turtlename:    " self "   :   " "    final destination:    " destination-lasttrip)
; ;                                 ]
;  ;                          ]
;   ;                    ] 
;
;
;;foreach sort firms with [color = green]   [ask ? [if ticks = 33 
;;                                 [file-print (word "   ticks:   " ticks  "    :    " "   firmname:    " self "   :   " "   people in city size:    " 
;;                                        count workers with [destination-lasttrip = round [pxcor] of one-of patches in-radius city-size * 100 +  round [pycor] of one-of patches in-radius city-size])
;;                                  ]
;;                            ]
;;                       ]          
;
;;foreach sort firms with [color = green] [ask ? [if ticks = 33 [file-print (word " firmname: " self " : " " residents:  "   people-in-city  ) ]]]     
;DIES IST DAS RICHTIGE!!!" foreach sort patches with [pxcor < 0 and any? workers-here]  [ask ? [if ticks = 33 
;                                 [file-print (word "   ticks:   " ticks  "    :    " "   patchname:    " self "   :   " "   people in city size:    " residents)
;                                  ]
;                                              ]
;                                        ]          
;
;BIS HIER!!!!!
;;if ticks = 32 [file-print (word "ticks:  " ticks "  clustering coefficient:  " ((sum [clustering-coefficient] of workers) / count workers ))]
;
;file-print (word "ticks: " ticks " meanerror: " mean-stockserror " stockserror :" (((count workers with [color = blue] / count workers ) - realstocks ) ^ 2) )
;;;foreach sort workers with [color = blue] [ask ? [if ticks = 1 or ticks = 240 
;;;                                  [file-print (word "   ticks:   " ticks  "    :    " "   turtlename:    " self "   :   " "    number_network_neighbors_blue:    " count information-neighbors with [color = blue])
;;;                                  ]
;;;                             ]
;;;                      ] 
;;
;;
;;foreach sort workers  [ask ? [if ticks = 1 or ticks = 32 
;;                                  [file-print (word "   ticks:   " ticks  "    :    " "   turtlename:    " self "   :   " "    number_network_neighbors:    " count information-neighbors)
;;                                  ]
;;                             ]
;;                      ] 
;end
;
;
;













@#$#@#$#@
GRAPHICS-WINDOW
187
32
1181
1031
61
60
8.0
1
10
1
1
1
0
0
0
1
-61
61
-60
60
0
0
1
ticks

BUTTON
22
12
85
45
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
107
12
170
45
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

SLIDER
1
271
173
304
percentage-at-home
percentage-at-home
0
100
94.4
0.1
1
NIL
HORIZONTAL

PLOT
999
10
1199
160
stocks-of-people
NIL
NIL
0.0
10.0
0.0
10.0
true
false
PENS
"number-migrants" 1.0 0 -13345367 true
"number-home" 1.0 0 -2674135 true
"realstocks" 1.0 0 -16777216 true

SLIDER
5
239
177
272
moving-costs
moving-costs
0
2000
1113
1
1
NIL
HORIZONTAL

SLIDER
21
170
193
203
number-people
number-people
0
10000
2860
10
1
NIL
HORIZONTAL

SLIDER
7
203
194
236
number-firms-blue
number-firms-blue
0
500
58
1
1
NIL
HORIZONTAL

SLIDER
1
350
199
383
production-parameter-blue
production-parameter-blue
0
1
0.5
0.01
1
NIL
HORIZONTAL

SLIDER
13
99
185
132
city-size
city-size
0
10
6.4
0.1
1
NIL
HORIZONTAL

SLIDER
9
134
190
167
number-firms-red
number-firms-red
0
500
199
1
1
NIL
HORIZONTAL

SLIDER
-18
430
220
463
production-parameter-red
production-parameter-red
0
1
0.17
0.01
1
NIL
HORIZONTAL

PLOT
796
154
996
304
migrant-flows
NIL
NIL
0.0
33.0
0.0
0.1
true
false
PENS
"migrants" 1.0 0 -13345367 true
"data-migrants" 1.0 0 -16777216 true

SLIDER
9
313
181
346
return-costs
return-costs
0
2000
1716
1
1
NIL
HORIZONTAL

MONITOR
366
10
464
55
never moved
count workers with [beforefirstmig = 1]
17
1
11

BUTTON
181
10
276
43
NIL
file-close
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

MONITOR
775
10
887
55
failed-migrants
count workers with [failed-migrant = 1]
17
1
11

SLIDER
1173
300
1405
333
parameter-comparative-earnings
parameter-comparative-earnings
0
2
1
0.1
1
NIL
HORIZONTAL

SLIDER
1183
577
1377
610
parameter-other-migrants
parameter-other-migrants
0
1
0.2
0.01
1
NIL
HORIZONTAL

SLIDER
1188
644
1370
677
parameter-ties-to-home
parameter-ties-to-home
0
2
0.12
0.01
1
NIL
HORIZONTAL

PLOT
803
338
1003
488
return-flows
NIL
NIL
0.0
33.0
0.0
0.1
true
false
PENS
"return-migrants" 1.0 0 -2674135 true
"data-return-migrants" 1.0 0 -16777216 true

SLIDER
1200
333
1372
366
parameter-homebias
parameter-homebias
0
2
1
0.01
1
NIL
HORIZONTAL

SLIDER
1168
754
1378
787
baseline_migrationprobability
baseline_migrationprobability
0
1
0.1
0.01
1
NIL
HORIZONTAL

SLIDER
1183
716
1377
749
baseline_returnprobability
baseline_returnprobability
0
1
0.38
0.01
1
NIL
HORIZONTAL

MONITOR
1244
55
1354
100
NIL
mean-stockserror
17
1
11

MONITOR
1220
230
1289
275
NIL
realstocks
17
1
11

@#$#@#$#@
WHAT IS IT?
-----------
This section could give a general understanding of what the model is trying to show or explain.


HOW IT WORKS
------------
This section could explain what rules the agents use to create the overall behavior of the model.


HOW TO USE IT
-------------
This section could explain how to use the model, including a description of each of the items in the interface tab.


THINGS TO NOTICE
----------------
This section could give some ideas of things for the user to notice while running the model.


THINGS TO TRY
-------------
This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.


EXTENDING THE MODEL
-------------------
This section could give some ideas of things to add or change in the procedures tab to make the model more complicated, detailed, accurate, etc.


NETLOGO FEATURES
----------------
This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.


RELATED MODELS
--------------
This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.


CREDITS AND REFERENCES
----------------------
This section could contain a reference to the model's URL on the web if it has one, as well as any other necessary credits or references.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 4.1.2
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="letzterversuch" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="48"/>
    <metric>mean-flowserror</metric>
    <metric>mean-stockserror</metric>
    <metric>[residents] of patches with [pxcor &lt; 0 and any? workers-here ]</metric>
    <metric>sum [residents] of patches with [pxcor &lt; 0 and any? workers-here ]</metric>
    <metric>mean [residents] of patches with [pxcor &lt; 0 and any? workers-here ]</metric>
    <metric>mean [residents] of patches with [pxcor &lt; 0 and any? workers-here ] / sum [residents] of patches with [pxcor &lt; 0 and any? workers-here ]</metric>
    <metric>standard-deviation [residents] of patches with [pxcor &lt; 0 and any? workers-here ]</metric>
    <metric>standard-deviation [residents] of patches with [pxcor &lt; 0 and any? workers-here ] / sum [residents] of patches with [pxcor &lt; 0 and any? workers-here ]</metric>
    <metric>median [residents] of patches with [pxcor &lt; 0 and any? workers-here]</metric>
    <metric>median [residents] of patches with [pxcor &lt; 0 and any? workers-here] / sum [residents] of patches with [pxcor &lt; 0 and any? workers-here]</metric>
    <metric>[movelist-at-tick48] of workers</metric>
    <metric>sum [movelist-at-tick48] of workers</metric>
    <metric>mean [movelist-at-tick48] of workers</metric>
    <metric>standard-deviation [movelist-at-tick48] of workers</metric>
    <steppedValueSet variable="parameter-other-migrants" first="0.1" step="0.1" last="1"/>
    <steppedValueSet variable="parameter-ties-to-home" first="0.1" step="0.1" last="2"/>
    <steppedValueSet variable="baseline_returnprobability" first="0" step="0.1" last="1"/>
    <steppedValueSet variable="baseline_migrationprobability" first="0" step="0.1" last="1"/>
  </experiment>
  <experiment name="spatial" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="33"/>
    <metric>[residents] of patches with [pxcor &lt; 0 and any? workers-here]</metric>
    <metric>sum [residents] of patches with [pxcor &lt; 0 and any? workers-here]</metric>
    <metric>mean [residents] of patches with [pxcor &lt; 0 and any? workers-here]</metric>
    <metric>mean [residents] of patches with [pxcor &lt; 0 and any? workers-here] / sum [residents] of patches with [pxcor &lt; 0 and any? workers-here]</metric>
    <metric>standard-deviation [residents] of patches with [pxcor &lt; 0 and any? workers-here]</metric>
    <metric>standard-deviation [residents] of patches with [pxcor &lt; 0 and any? workers-here] / sum [residents] of patches with [pxcor &lt; 0 and any? workers-here]</metric>
    <metric>median [residents] of patches with [pxcor &lt; 0 and any? workers-here]</metric>
    <metric>median [residents] of patches with [pxcor &lt; 0 and any? workers-here] / sum [residents] of patches with [pxcor &lt; 0 and any? workers-here]</metric>
    <steppedValueSet variable="parameter-other-migrants" first="0.8" step="0.1" last="1"/>
    <steppedValueSet variable="parameter-ties-to-home" first="0" step="0.1" last="2"/>
    <steppedValueSet variable="baseline_returnprobability" first="0" step="0.1" last="1"/>
    <steppedValueSet variable="baseline_migrationprobability" first="0" step="0.1" last="1"/>
  </experiment>
  <experiment name="stocks" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="34"/>
    <metric>mean-stockserror</metric>
    <steppedValueSet variable="parameter-other-migrants" first="0" step="0.1" last="1"/>
    <enumeratedValueSet variable="parameter-ties-to-home">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="baseline_returnprobability">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="baseline_migrationprobability">
      <value value="1"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="numbertrips" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="34"/>
    <metric>[movelist-at-tick17] of workers</metric>
    <metric>sum [movelist-at-tick17] of workers</metric>
    <metric>mean [movelist-at-tick17] of workers</metric>
    <metric>mean [movelist-at-tick17] of workers / sum [movelist-at-tick17] of workers</metric>
    <metric>standard-deviation [movelist-at-tick17] of workers</metric>
    <metric>standard-deviation [movelist-at-tick17] of workers / sum [movelist-at-tick17] of workers</metric>
    <metric>median [movelist-at-tick17] of workers</metric>
    <metric>median [movelist-at-tick17] of workers / sum [movelist-at-tick17] of workers</metric>
    <steppedValueSet variable="parameter-other-migrants" first="0" step="0.1" last="1"/>
    <enumeratedValueSet variable="parameter-ties-to-home">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="baseline_returnprobability">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="baseline_migrationprobability">
      <value value="1"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="stocks_and_number_of_trips" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="34"/>
    <metric>mean-stockserror</metric>
    <metric>[movelist-at-tick33] of workers</metric>
    <metric>sum [movelist-at-tick33] of workers</metric>
    <metric>mean [movelist-at-tick33] of workers</metric>
    <metric>mean [movelist-at-tick33] of workers / sum [movelist-at-tick33] of workers</metric>
    <metric>standard-deviation [movelist-at-tick33] of workers</metric>
    <metric>standard-deviation [movelist-at-tick33] of workers / sum [movelist-at-tick33] of workers</metric>
    <metric>median [movelist-at-tick33] of workers</metric>
    <metric>median [movelist-at-tick33] of workers / sum [movelist-at-tick33] of workers</metric>
    <steppedValueSet variable="parameter-other-migrants" first="0" step="0.1" last="1"/>
    <steppedValueSet variable="baseline_migrationprobability" first="0" step="0.1" last="1"/>
    <steppedValueSet variable="baseline_returnprobability" first="0" step="0.1" last="1"/>
    <steppedValueSet variable="parameter-ties-to-home" first="0" step="0.1" last="2"/>
  </experiment>
  <experiment name="finalone2" repetitions="10000" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="48"/>
    <metric>count workers with [migrant = 1] / number-people</metric>
    <metric>count workers with [return-migrant = 1] / number-people</metric>
    <enumeratedValueSet variable="parameter-other-migrants">
      <value value="0.2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="parameter-ties-to-home">
      <value value="0.12"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="baseline_returnprobability">
      <value value="0.38"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="baseline_migrationprobability">
      <value value="0.1"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
